//+------------------------------------------------------------------+
//|                                                        Pivot.mq4 |
//|                                                   MQL4 Community |
//|                                             http://astrofx.do.am |
//+------------------------------------------------------------------+
#property copyright "http://astrofx.do.am"
#property link      "http://astrofx.do.am"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 EMPTY
extern int ZeroLine=35;
extern int Step=25;
extern int _Frame=1;
extern bool =true;//
extern int  TimeFrame = 43200;//43200Month
extern int  Shift=0;
extern bool pivots = true;
extern bool Tagert = true;
extern int  ShiftTime = 2;
extern bool midpivots = true;
extern bool times = true;
extern color TimeFrameColor = Magenta;//=10080week),(DarkSeaGreen=43200Month)
extern int LabelShift = 20;
extern int LabelWidth = 8;
//---- input parameters

extern int       ExtFormula= 0;

extern int PivotLineStyle=0;
extern int PivotLineWidth=2;
extern int StartOfPeriodStyle=1;
extern int StartOfPeriodWidth=1;

extern int RSLineWidth=2;
extern int RSLineSTYLE=0;

extern int MidWidth=1;
extern int MIDSTYLE=1;

extern int EndOfPeriodStyle=2;

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double yesterday_opentime=0;
double today_opentime=0;
double today_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double R1,R2,R3,R4,R5,R6,R7,R8,R9;
double S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12;
double nQ=0;
double nD=0;
double D=0;
int Volum=0;


double rates_d1[2][6];
double ExtMapBuffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(4);
SetIndexStyle(0,DRAW_ARROW);
SetIndexArrow(0,159);
SetIndexBuffer(0, ExtMapBuffer1);

//---- indicators
 R1=0; R2=0; R3=0; R4=0; R5=0; R6=0; R7=0; R8=0; R9=0;
 S1=0; S2=0; S3=0; S4=0; S5=0; S6=0; S7=0; S8=0; S9=0; S10=0; S11=0; S12=0;

   switch( _Frame)
     {
      case 0 : Daily();  break;
      case 1 : Weekly ();  break;
      case 2 : Monthly(); 
     
     }

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
ObjectDelete("R1 Label_"+TimeFrame); 
ObjectDelete("R1 Line_"+TimeFrame);
ObjectDelete("R2 Label_"+TimeFrame);
ObjectDelete("R2 Line_"+TimeFrame);
ObjectDelete("R3 Label_"+TimeFrame);
ObjectDelete("R3 Line_"+TimeFrame);
ObjectDelete("P Label_"+TimeFrame);
ObjectDelete("P Line_"+TimeFrame);
ObjectDelete("R4 Label_"+TimeFrame);
ObjectDelete("R4 Line_"+TimeFrame);
ObjectDelete("R5 Label_"+TimeFrame);
ObjectDelete("R5 Line_"+TimeFrame);
ObjectDelete("R6 Label_"+TimeFrame);
ObjectDelete("R6 Line_"+TimeFrame);
ObjectDelete("R7 Label_"+TimeFrame);
ObjectDelete("R7 Line_"+TimeFrame);
ObjectDelete("R8 Label_"+TimeFrame);
ObjectDelete("R8 Line_"+TimeFrame);
ObjectDelete("R9 Label_"+TimeFrame);
ObjectDelete("R9 Line_"+TimeFrame);
ObjectDelete("S1 Label_"+TimeFrame);
ObjectDelete("S1 Line_"+TimeFrame);
ObjectDelete("S2 Label_"+TimeFrame);
ObjectDelete("S2 Line_"+TimeFrame);
ObjectDelete("S3 Label_"+TimeFrame);
ObjectDelete("S3 Line_"+TimeFrame);
ObjectDelete("S4 Label_"+TimeFrame);
ObjectDelete("S4 Line_"+TimeFrame);
ObjectDelete("S5 Label_"+TimeFrame);
ObjectDelete("S5 Line_"+TimeFrame);
ObjectDelete("S6 Label_"+TimeFrame);
ObjectDelete("S6 Line_"+TimeFrame);
ObjectDelete("S7 Label_"+TimeFrame);
ObjectDelete("S7 Line_"+TimeFrame);
ObjectDelete("S8 Label_"+TimeFrame);
ObjectDelete("S8 Line_"+TimeFrame);
ObjectDelete("S9 Label_"+TimeFrame);
ObjectDelete("S9 Line_"+TimeFrame);
ObjectDelete("Start Of Period_"+TimeFrame);
ObjectDelete("End Of Period_"+TimeFrame);



//----
   return(0);
  }
 void Daily() 
 {
 TimeFrameColor=Tan;
 TimeFrame = 1440;
 }
  void Weekly() 
 {
 TimeFrameColor= Magenta;
 TimeFrame = 10080;
 }
  void Monthly()
 {
 TimeFrame = 43200;
 TimeFrameColor= Green;
 } 
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- TODO: add your code here
 if(Symbol() == "EURUSD"&& TimeFrame==1440)
{
//PlaySound( "Options levels.wav");
}
else
{
//Comment("  ");

}
//---- exit if period is greater than daily charts


//---- Get new daily prices
//double rates_d1[2][6];    : 1 Open, 2 Low, 3 High, 4 Close, 5 Time  6 Volume
ArrayCopyRates(rates_d1, Symbol(), TimeFrame);
//ArrayResize(rates_d1,Shift);
yesterday_close = rates_d1[1+Shift][4];
yesterday_open = rates_d1[1+Shift][1];
today_open = rates_d1[0][1+Shift];
yesterday_high = rates_d1[1+Shift][3];
yesterday_low = rates_d1[1+Shift][2];
day_high = rates_d1[0][3+Shift];
day_low = rates_d1[0][2+Shift];
yesterday_opentime=rates_d1[1+Shift][0];
today_opentime=rates_d1[0+Shift][0];
Volum=rates_d1[0+Shift][6];

if(times&&Period() < 1440){

if(ObjectFind("Start Of Period_"+TimeFrame)!=0){
   ObjectCreate("Start Of Period_"+TimeFrame,OBJ_VLINE,0,today_opentime,0);
}
//if(ObjectFind("End Of Period_"+TimeFrame)!=0){
//   ObjectCreate("End Of Period_"+TimeFrame,OBJ_VLINE,0,today_opentime+60*TimeFrame,0);
//}
ObjectSet("Start Of Period_"+TimeFrame,OBJPROP_TIME1,today_opentime);
//ObjectSet("End Of Period_"+TimeFrame,OBJPROP_TIME1,today_opentime+60*TimeFrame);
ObjectSet("Start Of Period_"+TimeFrame,OBJPROP_COLOR,TimeFrameColor);
//ObjectSet("End Of Period_"+TimeFrame,OBJPROP_COLOR,LineColour);
ObjectSet("Start Of Period_"+TimeFrame,OBJPROP_STYLE,STYLE_DOT);
ObjectSet("Start Of Period_"+TimeFrame, OBJPROP_BACK, 1);
//ObjectSet("End Of Period_"+TimeFrame,OBJPROP_STYLE,EndOfPeriodStyle);
}
//---- Calculate Pivots

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
P = (yesterday_high + yesterday_low+yesterday_close) / 3;
//P = (yesterday_high + yesterday_low) / 2;

P= (NormalizeDouble(P,Digits-2)+ZeroLine*Point);
                  //ObjectCreate("AlexHacker012", OBJ_LABEL, 0, 0, 0);
                  //ObjectSetText("AlexHacker012"," psm="+P, 11, "Arial",Orange);
                 // ObjectSet("AlexHacker012", OBJPROP_CORNER, 2);
                 // ObjectSet("AlexHacker012", OBJPROP_XDISTANCE, 70);
                 // ObjectSet("AlexHacker012", OBJPROP_YDISTANCE, 90); 
R1 = P+Step*Point;//Q*0.118;
R2 = P+2*Step*Point;//Q*0.261;
R3 = P+3*Step*Point;//Q*0.261;
R4 = P+4*Step*Point;//Q*0.736;
R5 = P+5*Step*Point;//Q*1.118;
R6 = P+6*Step*Point;//Q*1.5;
R7 = P+7*Step*Point;//Q*2.118;
R8 = P+8*Step*Point;//Q*3.736;
R9 = P+9*Step*Point;//Q*6.318;

S1 = P-1*Step*Point;//Q*0.118;
S2 = P-2*Step*Point;//Q*0.261;
S3 = P-3*Step*Point;//Q*0.261;
S4 = P-4*Step*Point;//Q*0.736;
S5 = P-5*Step*Point;//Q*1.118;
S6 = P-6*Step*Point;//Q*1.5;
S7 = P-7*Step*Point;//Q*2.118;
S8 = P-8*Step*Point;//Q*3.736;
S9 = P-9*Step*Point;//Q*6.318;

if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}

 if(MathAbs(ShiftTime)>23) ShiftTime=0;
 //  Comment("Shift Hours = ", ShiftTime);
   if(ShiftTime<0) ShiftTime+=24;//   ShiftTime  24 
   ShiftTime*=3600;//   ShiftTime  3600(   3600 )

//Comment("CurTime   "+(TimeToStr( CurTime()+ShiftTime, TIME_SECONDS ))+"\n"+"Shift Hours = ", (ShiftTime/60)/60);//    ,     

//---- Set line labels on chart window

//---- Pivot Lines
if (Tagert==true&&Period()<TimeFrame){
  
       if(ObjectFind("P label_"+TimeFrame) != 0)
     {
      ObjectCreate("P label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, P);
     ObjectSetText("P label_"+TimeFrame,FTF(TimeFrame)+"   P   "+"("+DoubleToStr(P,Digits)+")",LabelWidth, "Arial", TimeFrameColor);
      }
      else
     {
     ObjectMove("P label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, P);
     }
     
     

////////////////////////////
     if(ObjectFind("R1 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R1 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R1);
       ObjectSetText("R1 label_"+TimeFrame,FTF(TimeFrame)+"R  1   "+"( "+DoubleToStr(R1,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R1 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R1);
      }
      ///////////////////////
      if(ObjectFind("R2 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R2 label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, R2);
       ObjectSetText("R2 label_"+TimeFrame,FTF(TimeFrame)+" R2 50%  "+"("+DoubleToStr(R2,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R2 label_"+TimeFrame, 0,  Time[0]-LabelShift*TimeFrame, R2);
      }
////////////////////////////
      if(ObjectFind("R3 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R3 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R3);
       ObjectSetText("R3 label_"+TimeFrame,FTF(TimeFrame)+" R3 100%  "+"("+DoubleToStr(R3,Digits)+")", LabelWidth, "Arial",TimeFrameColor);
      }
      else
      {
      ObjectMove("R3 label_"+TimeFrame, 0,Time[0]-LabelShift*TimeFrame, R3);
      }
     ////////////////////////////
     if(ObjectFind("R4 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R4 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R4);
       ObjectSetText("R4 label_"+TimeFrame,FTF(TimeFrame)+" R4 123% "+"( "+DoubleToStr(R4,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R4 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R4);
      }
      ////////////////////////////
     if(ObjectFind("R5 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R5 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R5);
       ObjectSetText("R5 label_"+TimeFrame,FTF(TimeFrame)+" R5 161%  "+"( "+DoubleToStr(R5,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R5 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R5);
      }
      ////////////////////////////
     if(ObjectFind("R6 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R6 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R6);
       ObjectSetText("R6 label_"+TimeFrame,FTF(TimeFrame)+" R6 200%  "+"( "+DoubleToStr(R6,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R6 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R6);
      }
      ////////////////////////////
     if(ObjectFind("R7 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R7 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R7);
       ObjectSetText("R7 label_"+TimeFrame,FTF(TimeFrame)+" R7 261%  "+"( "+DoubleToStr(R7,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R7 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R7);
      }
      ////////////////////////////
     if(ObjectFind("R8 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R8 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R8);
       ObjectSetText("R8 label_"+TimeFrame,FTF(TimeFrame)+" R8 423%  "+"( "+DoubleToStr(R8,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R9 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R8);
      }
      ////////////////////////////
     if(ObjectFind("R9 label_"+TimeFrame) != 0)
      {
      ObjectCreate("R9 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, R9);
       ObjectSetText("R9 label_"+TimeFrame,FTF(TimeFrame)+" R9 638%  "+"( "+DoubleToStr(R9,Digits)+") ", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("R9 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, R9);
      }
      ////////////////////////--------"P label_"--------////////////////
      if(ObjectFind("P label_"+TimeFrame) != 0)
     {
      ObjectCreate("P label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, P);
     ObjectSetText("P label_"+TimeFrame,FTF(TimeFrame)+"   P   "+"("+DoubleToStr(P,Digits)+")",LabelWidth, "Arial", TimeFrameColor);
      }
      else
     {
     ObjectMove("P label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, P);
     }
    if(ObjectFind("S1 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S1 label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, S1);
      ObjectSetText("S1 label_"+TimeFrame,FTF(TimeFrame)+"S  1   "+"("+DoubleToStr(S1,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S1 label_"+TimeFrame, 0,  Time[0]-LabelShift*TimeFrame, S1);
      }
      

      if(ObjectFind("S1 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S1 label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, S1);
      ObjectSetText("S1 label_"+TimeFrame,FTF(TimeFrame)+"S  1   "+"("+DoubleToStr(S1,Digits)+")", LabelWidth, "Arial",TimeFrameColor);
      }
      else
      {
      ObjectMove("S1 label_"+TimeFrame, 0,  Time[0]-LabelShift*TimeFrame, S1);
      }

      if(ObjectFind("S2 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S2 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S2);
      ObjectSetText("S2 label_"+TimeFrame,FTF(TimeFrame)+" S2 50%  "+"("+DoubleToStr(S2,Digits)+")", LabelWidth, "Arial",TimeFrameColor);
      }
      else
      {
      ObjectMove("S2 label_"+TimeFrame, 0,Time[0]-LabelShift*TimeFrame, S2);
      }
     
      if(ObjectFind("S3 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S3 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S3);
      ObjectSetText("S3 label_"+TimeFrame,FTF(TimeFrame)+"S  3  100% "+"("+DoubleToStr(S3,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S3 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, S3);
      }
      
      
      if(ObjectFind("S4 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S4 label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, S4);
      ObjectSetText("S4 label_"+TimeFrame,FTF(TimeFrame)+" S4  126% "+"("+DoubleToStr(S4,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S4 label_"+TimeFrame, 0,  Time[0]-LabelShift*TimeFrame, S4);
      }
      if(ObjectFind("S5 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S5 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S5);
      ObjectSetText("S5 label_"+TimeFrame,FTF(TimeFrame)+" S5 161%  "+"("+DoubleToStr(S5,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S5 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, S5);
      }
      if(ObjectFind("S6 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S6 label_"+TimeFrame, OBJ_TEXT, 0,Time[0]-LabelShift*TimeFrame, S6);
      ObjectSetText("S6 label_"+TimeFrame,FTF(TimeFrame)+" S6  200% "+"("+DoubleToStr(S6,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S6 label_"+TimeFrame, 0,  Time[0]-LabelShift*TimeFrame, S6);
      }
      if(ObjectFind("S7 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S7 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S7);
      ObjectSetText("S7 label_"+TimeFrame,FTF(TimeFrame)+" S7 261%  "+"("+DoubleToStr(S7,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S8 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, S8);
      }
            if(ObjectFind("S8 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S8 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S8);
      ObjectSetText("S8 label_"+TimeFrame,FTF(TimeFrame)+" S8 423%  "+"("+DoubleToStr(S8,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S9 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, 8);
      }
            if(ObjectFind("S9 label_"+TimeFrame) != 0)
      {
      ObjectCreate("S9 label_"+TimeFrame, OBJ_TEXT, 0, Time[0]-LabelShift*TimeFrame, S9);
      ObjectSetText("S9 label_"+TimeFrame,FTF(TimeFrame)+" S9 632%  "+"("+DoubleToStr(S9,Digits)+")", LabelWidth, "Arial", TimeFrameColor);
      }
      else
      {
      ObjectMove("S9 label_"+TimeFrame, 0, Time[0]-LabelShift*TimeFrame, S9);
      }
 }
//---  Draw  Pivot lines on chart
 if (pivots==true&&Period()<TimeFrame){
      if(ObjectFind("S1 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S1 line_"+TimeFrame, OBJ_TREND,0, today_opentime, S1,today_opentime+60*TimeFrame, S1);
      ObjectSet("S1 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("S1 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("S1 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("S1 line_"+TimeFrame, OBJPROP_RAY, false); 
      ObjectSetText("S1 line_"+TimeFrame," ."); 
      ObjectSet("S1 line_"+TimeFrame, OBJPROP_BACK, true);   
      }
      else
      {
      ObjectMove("S1 line_"+TimeFrame, 0, today_opentime, S1);
      ObjectMove("S1 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S1);      
      }

      if(ObjectFind("S2 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S2 line_"+TimeFrame, OBJ_TREND,0, today_opentime, S2,today_opentime+60*TimeFrame, S2);
      ObjectSet("S2 line_"+TimeFrame, OBJPROP_STYLE,RSLineSTYLE);
      ObjectSet("S2 line_"+TimeFrame, OBJPROP_COLOR,TimeFrameColor);
      ObjectSet("S2 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("S2 line_"+TimeFrame, OBJPROP_RAY, false);
       ObjectSetText("S2 line_"+TimeFrame," ..");
        ObjectSet("S2 line_"+TimeFrame, OBJPROP_BACK, true);        
      }
      else
      {
      ObjectMove("S2 line_"+TimeFrame, 0, today_opentime, S2);
      ObjectMove("S2 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, S2);      
      }

      if(ObjectFind("S3 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S3 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S3,today_opentime+60*TimeFrame, S3);
      ObjectSet("S3 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S3 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("S3 line_"+TimeFrame, OBJPROP_WIDTH, RSLineSTYLE);
      ObjectSet("S3 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S3 line_"+TimeFrame," ..."); 
       ObjectSet("S3 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S3 line_"+TimeFrame, 0, today_opentime, S3);
      ObjectMove("S3 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S3);      
      }
      
      if(ObjectFind("S4 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S4 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S4,today_opentime+60*TimeFrame, S4);
      ObjectSet("S4 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S4 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("S4 line_"+TimeFrame, OBJPROP_WIDTH, RSLineSTYLE);
      ObjectSet("S4 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S4 line_"+TimeFrame," ..."); 
       ObjectSet("S4 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S4 line_"+TimeFrame, 0, today_opentime, S4);
      ObjectMove("S4 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S4);      
      }

   if(ObjectFind("S5 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S5 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S5,today_opentime+60*TimeFrame, S5);
      ObjectSet("S5 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S5 line_"+TimeFrame, OBJPROP_COLOR, Red);
      ObjectSet("S5 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("S5 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S5 line_"+TimeFrame," ..."); 
       ObjectSet("S5 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S5 line_"+TimeFrame, 0, today_opentime, S5);
      ObjectMove("S5 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S5);      
      }
      
      if(ObjectFind("S6 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S6 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S6,today_opentime+60*TimeFrame, S6);
      ObjectSet("S6 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S6 line_"+TimeFrame, OBJPROP_COLOR, RoyalBlue);
      ObjectSet("S6 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("S6 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S3 line_"+TimeFrame," ..."); 
       ObjectSet("S3 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S6 line_"+TimeFrame, 0, today_opentime, S6);
      ObjectMove("S6 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S6);      
      }
      
      if(ObjectFind("S7 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S7 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S7,today_opentime+60*TimeFrame, S7);
      ObjectSet("S7 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S7 line_"+TimeFrame, OBJPROP_COLOR, Yellow);
      ObjectSet("S7 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("S7 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S7 line_"+TimeFrame," ..."); 
       ObjectSet("S7 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S7 line_"+TimeFrame, 0, today_opentime, S7);
      ObjectMove("S7 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S7);      
      }
      
      if(ObjectFind("S8 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S8 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S8,today_opentime+60*TimeFrame, S8);
      ObjectSet("S8 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S8 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("S8 line_"+TimeFrame, OBJPROP_WIDTH, RSLineSTYLE);
      ObjectSet("S8 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S8 line_"+TimeFrame," ..."); 
       ObjectSet("S8 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S8 line_"+TimeFrame, 0, today_opentime, S8);
      ObjectMove("S8 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S8);      
      }
      
      if(ObjectFind("S9 line_"+TimeFrame) != 0)
      {
      ObjectCreate("S9 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, S9,today_opentime+60*TimeFrame, S9);
      ObjectSet("S9 line_"+TimeFrame, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S9 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("S9 line_"+TimeFrame, OBJPROP_WIDTH, RSLineSTYLE);
      ObjectSet("S9 line_"+TimeFrame, OBJPROP_RAY, false);
      ObjectSetText("S9 line_"+TimeFrame," ..."); 
       ObjectSet("S9 line_"+TimeFrame, OBJPROP_BACK, true);  
      }
      else
      {
      ObjectMove("S9 line_"+TimeFrame, 0, today_opentime, S9);
      ObjectMove("S9 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, S9);      
      }
      
      
      if(ObjectFind("P line_"+TimeFrame) != 0)
       {
      ObjectCreate("P line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, P,today_opentime+60*TimeFrame, P);
     ObjectSet("P line_", OBJPROP_PRICE1, P);
      ObjectSet("P line_", OBJPROP_PRICE2, P);
      ObjectSet("P line_"+TimeFrame,OBJPROP_TIME1,today_opentime);
      ObjectSet("P line_"+TimeFrame,OBJPROP_TIME2,today_opentime+60*TimeFrame);
      ObjectSet("P line_"+TimeFrame, OBJPROP_STYLE, PivotLineStyle);
      ObjectSet("P line_"+TimeFrame, OBJPROP_COLOR, Orange);
      ObjectSet("P line_"+TimeFrame, OBJPROP_WIDTH, PivotLineWidth);
      ObjectSet("P line_"+TimeFrame, OBJPROP_RAY, false);      
       }
 else
      {
      ObjectMove("P line_"+TimeFrame, 0,today_opentime, P);
      ObjectMove("P line_"+TimeFrame, 1,today_opentime+60*TimeFrame, P);      
      }

      if(ObjectFind("R1 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R1 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, R1,today_opentime+60*TimeFrame, R1);
      ObjectSet("R1 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R1 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R1 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R1 line_"+TimeFrame, OBJPROP_RAY, false);  
      ObjectSetText("R1 line_"+TimeFrame," ."); 
       ObjectSet("R1 line_"+TimeFrame, OBJPROP_BACK, true);     
      }
      else
      {
      ObjectMove("R1 line_"+TimeFrame, 0,today_opentime, R1);
      ObjectMove("R1 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R1); 
            
      }

      if(ObjectFind("R2 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R2 line_"+TimeFrame, OBJ_TREND, 0, today_opentime, R2,today_opentime+60*TimeFrame, R2);
      ObjectSet("R2 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R2 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R2 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R2 line_"+TimeFrame, OBJPROP_RAY, false);  
       ObjectSetText("R2 line_"+TimeFrame," ..");
        ObjectSet("R2 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R2 line_"+TimeFrame, 0, today_opentime, R2);
      ObjectMove("R2 line_"+TimeFrame, 1, today_opentime+60*TimeFrame, R2);      
      }

      if(ObjectFind("R3 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R3 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R3,today_opentime+60*TimeFrame, R3);
      ObjectSet("R3 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R3 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R3 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R3 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R3 line_"+TimeFrame," ...");
        ObjectSet("R3 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R3 line_"+TimeFrame, 0, today_opentime, R3);
      ObjectMove("R3 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R3);      
      }
      if(ObjectFind("R4 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R4 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R4,today_opentime+60*TimeFrame, R4);
      ObjectSet("R4 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R4 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R4 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R4 line_"+TimeFrame, OBJPROP_RAY, false); 
      ObjectSetText("R4 line_"+TimeFrame," ...");
      ObjectSet("R4 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R4 line_"+TimeFrame, 0, today_opentime, R4);
      ObjectMove("R4 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R4);      
      }
      
      if(ObjectFind("R5 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R5 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R5,today_opentime+60*TimeFrame, R5);
      ObjectSet("R5 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R5 line_"+TimeFrame, OBJPROP_COLOR, Red);
      ObjectSet("R5 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("R5 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R5 line_"+TimeFrame," ...");
        ObjectSet("R5 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R5 line_"+TimeFrame, 0, today_opentime, R5);
      ObjectMove("R5 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R5);      
      }
      
      if(ObjectFind("R6 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R6 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R6,today_opentime+60*TimeFrame, R6);
      ObjectSet("R6 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R6 line_"+TimeFrame, OBJPROP_COLOR, RoyalBlue);
      ObjectSet("R6 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("R6 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R6 line_"+TimeFrame," ...");
        ObjectSet("R6 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R6 line_"+TimeFrame, 0, today_opentime, R6);
      ObjectMove("R6 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R6);      
      }
      
      if(ObjectFind("R7 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R7 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R7,today_opentime+60*TimeFrame, R7);
      ObjectSet("R7 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R7 line_"+TimeFrame, OBJPROP_COLOR, Yellow);
      ObjectSet("R7 line_"+TimeFrame, OBJPROP_WIDTH, 2);
      ObjectSet("R7 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R7 line_"+TimeFrame," ...");
        ObjectSet("R7 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R7 line_"+TimeFrame, 0, today_opentime, R7);
      ObjectMove("R7 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R7);      
      }
      if(ObjectFind("R8 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R8 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R8,today_opentime+60*TimeFrame, R8);
      ObjectSet("R8 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R8 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R8 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R8 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R8 line_"+TimeFrame," ...");
        ObjectSet("R8 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R8 line_"+TimeFrame, 0, today_opentime, R8);
      ObjectMove("R8 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R8);      
      }
      
      if(ObjectFind("R9 line_"+TimeFrame) != 0)
      {
      ObjectCreate("R9 line_"+TimeFrame, OBJ_TREND, 0,  today_opentime, R9,today_opentime+60*TimeFrame, R9);
      ObjectSet("R9 line_"+TimeFrame, OBJPROP_STYLE, RSLineSTYLE);
      ObjectSet("R9 line_"+TimeFrame, OBJPROP_COLOR, TimeFrameColor);
      ObjectSet("R9 line_"+TimeFrame, OBJPROP_WIDTH, RSLineWidth);
      ObjectSet("R9 line_"+TimeFrame, OBJPROP_RAY, false); 
       ObjectSetText("R9 line_"+TimeFrame," ...");
        ObjectSet("R9 line_"+TimeFrame, OBJPROP_BACK, true);       
      }
      else
      {
      ObjectMove("R9 line_"+TimeFrame, 0, today_opentime, R9);
      ObjectMove("R9 line_"+TimeFrame, 1,today_opentime+60*TimeFrame, R9);      
      }
      //---- Draw Midpoint Pivots on Chart
      

   }
    
//---- End of Pivot Line Draw 


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                  //
                                                                                                                   
                                                                                                                  //
                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////



 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+
string FTF(int tf){
   int t; 
   if(tf==0)t=Period();else t=tf;
   if(t==1)return("M1");
   if(t==5)return("M5");  
   if(t==15)return("M15");
   if(t==30)return("M30");      
   if(t==60)return("H1");
   if(t==240)return("H4");  
   if(t==1440)return("D");
   if(t==10080)return("W");  
   if(t==43200)return("MN");
}
  